
/*
 * Copyright (c) Developers of Binary Utility
 * Redistributable and modifiable. Please see license.readme for details.
 *
 * ammendment history
 *      <date>			        <changed by>		<summary of changes>
 * 26 November 2004  	    Jonee Ryan Ty		First documented history
 *
 */

#include <stdio.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

enum boolean {FALSE = 0, TRUE};

int error = FALSE;

int main(int argc, char* argv[]) {

	FILE *inFile;
	void parse(char *, FILE *);

	if (argc != 2) {	// check for parameter count
		fprintf(stderr, "wrong parameter count\n");
		fprintf(stderr, "<input file>\n");
		error = TRUE;
	}

	if (argc > 1) {
		inFile = fopen(argv[1], "r");
		if (inFile == NULL) {
			fprintf(stderr, "file does not exist: %s\n", argv[1]);
			error = TRUE;
		}
	}

	if (error)
		exit(1);

	parse(argv[1], inFile);
	fclose(inFile);
}

void parse(char *fileName, FILE *inFile) {

	int i = 0, iTmp;
	char getCharEquiv(int);
        struct stat st;

	inFile = fopen(fileName, "r");

	stat(fileName, &st);

	for (; i < st.st_size; i++) {
		fread(&iTmp, 1, 1, inFile);
		printf("%c%c", getCharEquiv(iTmp / 16), getCharEquiv(iTmp % 16));
	}
}

/**
 * If parameter is 16, output is F etc..
 */
char getCharEquiv(int hexVal) {

	if (hexVal < 10)
		return '0' + hexVal;

	else
		return 'A' + hexVal - 10;

}




